﻿#ifndef __ZIMERRORCODE_H__
#define __ZIMERRORCODE_H__

//
//  ZIMErrorCode.h
//  ZIM
//
//  Copyright © 2021 Zego. All rights reserved.
//

namespace zim {

// The define of error code.
//
// Description: Developers can find the details of the error code in the developer documentation website according to the error code.
//
// Use cases: It can be used to collect and record errors in the process of using the SDK.

enum ZIMErrorCode {

    ZIM_ERROR_CODE_SUCCESS = 0,
    ZIM_ERROR_CODE_FAILED = 1,

    ZIM_ERROR_CODE_COMMON_MODULE_PARAMS_INVALID = 6000001,
    ZIM_ERROR_CODE_COMMON_MODULE_ENGINE_NOT_INIT = 6000002,
    ZIM_ERROR_CODE_COMMON_MODULE_INVALID_APPID = 6000003,
    ZIM_ERROR_CODE_COMMON_MODULE_TRIGGER_SDK_FREQUENCY_LIMIT = 6000004,
    ZIM_ERROR_CODE_COMMON_MODULE_TRIGGER_SERVER_FREQUENCY_LIMIT = 6000005,
    ZIM_ERROR_CODE_COMMON_MODULE_SWITCH_SERVER_ERROR = 6000006,
    ZIM_ERROR_CODE_COMMON_MODULE_IM_SERVER_ERROR = 6000007,
    ZIM_ERROR_CODE_COMMON_MODULE_IM_DATABASE_ERROR = 6000008,
    ZIM_ERROR_CODE_COMMON_MODULE_IM_SERVER_DISCONNECT = 6000009,
    ZIM_ERROR_CODE_COMMON_MODULE_UPLOAD_LOG_ERROR = 6000010,
    ZIM_ERROR_CODE_COMMON_MODULE_USER_IS_NOT_EXIST = 6000011,
    ZIM_ERROR_CODE_COMMON_MODULE_USER_INFO_QUERIED_LIMIT = 6000012,
    ZIM_ERROR_CODE_COMMON_MODULE_UNSUPPORTED_REQUEST = 6000013,
    ZIM_ERROR_CODE_COMMON_MODULE_EXCEED_DAU_LIMIT = 6000015,
    ZIM_ERROR_CODE_COMMON_MODULE_EXCEED_MAU_LIMIT = 6000016,

    ZIM_ERROR_CODE_NETWORK_MODULE_COMMON_ERROR = 6000101,
    ZIM_ERROR_CODE_NETWORK_MODULE_SERVER_ERROR = 6000102,
    ZIM_ERROR_CODE_NETWORK_MODULE_TOKEN_INVALID = 6000103,
    ZIM_ERROR_CODE_NETWORK_MODULE_NETWORK_ERROR = 6000104,
    ZIM_ERROR_CODE_NETWORK_MODULE_REQUEST_TIMEOUT = 6000105,
    ZIM_ERROR_CODE_NETWORK_MODULE_TOKEN_EXPIRED = 6000106,
    ZIM_ERROR_CODE_NETWORK_MODULE_TOKEN_VERSION_ERROR = 6000107,
    ZIM_ERROR_CODE_NETWORK_MODULE_TOKEN_TIME_IS_TOO_SHORT = 6000108,
    ZIM_ERROR_CODE_NETWORK_MODULE_USER_HAS_ALREADY_LOGGED = 6000111,
    ZIM_ERROR_CODE_NETWORK_MODULE_USER_IS_NOT_LOGGED = 6000121,
    ZIM_ERROR_CODE_NETWORK_MODULE_USER_HAS_ALREADY_LOGGED_OUT = 6000122,
    ZIM_ERROR_CODE_NETWORK_MODULE_USER_OFFLINE = 6000123,
    ZIM_ERROR_CODE_NETWORK_MODULE_USER_ID_ERROR = 6000124,

    ZIM_ERROR_CODE_MESSAGE_MODULE_COMMON_ERROR = 6000201,
    ZIM_ERROR_CODE_MESSAGE_MODULE_SERVER_ERROR = 6000202,
    ZIM_ERROR_CODE_MESSAGE_MODULE_SEND_MESSAGE_FAILED = 6000203,
    ZIM_ERROR_CODE_MESSAGE_MODULE_TARGET_DOES_NOT_EXIST = 6000204,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_ERROR = 6000210,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_NOT_EXIST = 6000211,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_SERVER_ERROR = 6000212,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_TYPE_UNSUPPORTED = 6000213,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_SIZE_INVALID = 6000214,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_DURATION_INVALID = 6000215,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_PERMISSION_DENIED = 6000216,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_DOWNLOAD_FAILED = 6000217,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_DOWNLOAD_LIMIT = 6000218,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_DOWNLOAD_URL_NOT_FOUND = 6000219,
    ZIM_ERROR_CODE_MESSAGE_MODULE_FILE_DOWNLOAD_HTTP_REQUEST_SERVER_ERROR = 6000220,
    ZIM_ERROR_CODE_MESSAGE_MODULE_AUDIT_REJECTED = 6000221,
    ZIM_ERROR_CODE_MESSAGE_MODULE_AUDIT_FAILED = 6000222,
    ZIM_ERROR_CODE_MESSAGE_MODULE_AUDIT_CUSTOM_SENT_REJECTED = 6000230,
    ZIM_ERROR_CODE_MESSAGE_MODULE_MUTED = 6000231,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CACHE_FILE_OPEN_FAILED = 6000240,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CACHE_FILE_EXPORT_OR_IMPORT_IS_IN_PROGRESS_CURRENTLY = 6000241,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CACHE_FILE_ONLY_CAN_IMPORT_CACHE_OF_ONESELF = 6000242,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CACHE_FILE_EXPORT_FAILED = 6000243,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CACHE_FILE_IMPORT_FAILED = 6000244,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CACHE_FILE_JSON_PARSE_FAILED = 6000245,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CALL_ERROR = 6000270,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CANCEL_CALL_ERROR = 6000271,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CALL_SERVER_ERROR = 6000272,
    ZIM_ERROR_CODE_MESSAGE_MODULE_IS_NOT_INVITOR = 6000273,
    ZIM_ERROR_CODE_MESSAGE_MODULE_IS_NOT_INVITEE = 6000274,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CALL_ALREADY_EXISTS = 6000275,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CALL_DOES_NOT_EXIST = 6000276,
    ZIM_ERROR_CODE_MESSAGE_MODULE_RECEIPT_READ_ERROR = 6000277,
    ZIM_ERROR_CODE_MESSAGE_MODULE_MESSAGE_EXCEEDS_REVOKE_TIME = 6000278,
    ZIM_ERROR_CODE_MESSAGE_MODULE_MESSAGE_HAS_BEEN_REVOKED = 6000279,
    ZIM_ERROR_CODE_MESSAGE_MODULE_MESSAGE_REACTION_TYPE_EXISTED = 6000280,
    ZIM_ERROR_CODE_MESSAGE_MODULE_CALL_INVITE_USER_DOES_NOT_EXIST = 6000281,
    ZIM_ERROR_CODE_MESSAGE_MODULE_MESSAGE_RECEIPT_LIMIT = 6000282,
    ZIM_ERROR_CODE_MESSAGE_MODULE_USER_ALREADY_IN_THE_CALL = 6000283,
    ZIM_ERROR_CODE_MESSAGE_MODULE_SENDER_IN_BLACKLIST = 6000284,

    ZIM_ERROR_CODE_ROOM_MODULE_COMMON_ERROR = 6000301,
    ZIM_ERROR_CODE_ROOM_MODULE_SERVER_ERROR = 6000302,
    ZIM_ERROR_CODE_ROOM_MODULE_CREATE_ROOM_ERROR = 6000303,
    ZIM_ERROR_CODE_ROOM_MODULE_JOIN_ROOM_ERROR = 6000304,
    ZIM_ERROR_CODE_ROOM_MODULE_LEAVE_ROOM_ERROR = 6000306,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_MEMBER_QUERY_FAILED = 6000310,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_MEMBER_QUERY_FAILED_COMPLETELY = 6000311,
    ZIM_ERROR_CODE_ROOM_MODULE_USER_IS_ALREADY_IN_THE_ROOM = 6000320,
    ZIM_ERROR_CODE_ROOM_MODULE_USER_IS_NOT_IN_THE_ROOM = 6000321,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_ROOM_DOES_NOT_EXIST = 6000322,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_ROOM_ALREADY_EXISTS = 6000323,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_NUMBER_OF_EXISTING_ROOMS_HAS_REACHED_LIMIT = 6000324,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_NUMBER_OF_JOINED_ROOMS_HAS_REACHED_LIMIT = 6000325,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_ROOM_IS_CONNECTING = 6000326,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_ATTRIBUTES_COMMON_ERROR = 6000330,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_ATTRIBUTES_OPERATION_FAILED_COMPLETELY = 6000331,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_ATTRIBUTES_OPERATION_FAILED_PARTLY = 6000332,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_ATTRIBUTES_QUERY_FAILED = 6000333,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_NUMBER_OF_ROOM_ATTRIBUTES_EXCEEDS_LIMIT = 6000334,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_LENGTH_OF_ROOM_ATTRIBUTE_KEY_EXCEEDS_LIMIT = 6000335,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_LENGTH_OF_ROOM_ATTRIBUTE_VALUE_EXCEEDS_LIMIT = 6000336,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_TOTAL_LENGTH_OF_ROOM_ATTRIBUTES_VALUE_EXCEEDS_LIMIT = 6000337,
    ZIM_ERROR_CODE_ROOM_MODULE_ROOM_MEMBER_ATTRIBUTES_COMMON_ERROR = 6000350,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_TOTAL_LENGTH_OF_ROOM_MEMBER_ATTRIBUTES_EXCEEDS_LIMIT = 6000351,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_LENGTH_OF_ROOM_MEMBER_ATTRIBUTES_KEY_EXCEEDS_LIMIT = 6000352,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_LENGTH_OF_ROOM_MEMBER_ATTRIBUTES_VALUE_EXCEEDS_LIMIT = 6000353,
    ZIM_ERROR_CODE_ROOM_MODULE_THE_MEMBER_NUMBER_OF_ROOM_MEMBER_ATTRIBUTES_EXCEEDS_LIMIT = 6000357,
    ZIM_ERROR_CODE_ZPNS_MODULE_PUSH_ID_INVALID = 6000401,

    ZIM_ERROR_CODE_GROUP_MODULE_COMMON_ERROR = 6000501,
    ZIM_ERROR_CODE_GROUP_MODULE_SERVER_ERROR = 6000502,
    ZIM_ERROR_CODE_GROUP_MODULE_CREATE_GROUP_ERROR = 6000503,
    ZIM_ERROR_CODE_GROUP_MODULE_DISMISS_GROUP_ERROR = 6000504,
    ZIM_ERROR_CODE_GROUP_MODULE_JOIN_GROUP_ERROR = 6000505,
    ZIM_ERROR_CODE_GROUP_MODULE_LEAVE_GROUP_ERROR = 6000506,
    ZIM_ERROR_CODE_GROUP_MODULE_KICK_OUT_GROUP_MEMBER_ERROR = 6000507,
    ZIM_ERROR_CODE_GROUP_MODULE_INVITE_USER_INTO_GROUP_ERROR = 6000508,
    ZIM_ERROR_CODE_GROUP_MODULE_TRANSFER_OWNER_ERROR = 6000509,
    ZIM_ERROR_CODE_GROUP_MODULE_UPDATE_GROUP_INFO_ERROR = 6000510,
    ZIM_ERROR_CODE_GROUP_MODULE_QUERY_GROUP_INFO_ERROR = 6000511,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_ATTRIBUTES_OPERATION_FAILED = 6000512,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_ATTRIBUTES_QUERY_FAILED = 6000513,
    ZIM_ERROR_CODE_GROUP_MODULE_UPDATE_GROUP_MEMBER_INFO_ERROR = 6000514,
    ZIM_ERROR_CODE_GROUP_MODULE_QUERY_GROUP_MEMBER_INFO_ERROR = 6000515,
    ZIM_ERROR_CODE_GROUP_MODULE_QUERY_GROUP_LIST_ERROR = 6000516,
    ZIM_ERROR_CODE_GROUP_MODULE_QUERY_GROUP_MEMBER_LIST_ERROR = 6000517,
    ZIM_ERROR_CODE_GROUP_MODULE_USER_IS_NOT_IN_THE_GROUP = 6000521,
    ZIM_ERROR_CODE_GROUP_MODULE_MEMBER_IS_ALREADY_IN_THE_GROUP = 6000522,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_DOES_NOT_EXIST = 6000523,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_ALREADY_EXISTS = 6000524,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_MEMBER_HAS_REACHED_LIMIT = 6000525,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_ATTRIBUTE_DOES_NOT_EXIST = 6000526,
    ZIM_ERROR_CODE_GROUP_MODULE_GROUP_WITH_DISMISSED = 6000527,
    ZIM_ERROR_CODE_GROUP_MODULE_THE_NUMBER_OF_GROUP_ATTRIBUTES_EXCEEDS_LIMIT = 6000531,
    ZIM_ERROR_CODE_GROUP_MODULE_THE_LENGTH_OF_GROUP_ATTRIBUTE_KEY_EXCEEDS_LIMIT = 6000532,
    ZIM_ERROR_CODE_GROUP_MODULE_THE_LENGTH_OF_GROUP_ATTRIBUTE_VALUE_EXCEEDS_LIMIT = 6000533,
    ZIM_ERROR_CODE_GROUP_MODULE_THE_TOTAL_LENGTH_OF_GROUP_ATTRIBUTE_VALUE_EXCEEDS_LIMIT = 6000534,
    ZIM_ERROR_CODE_GROUP_MODULE_NO_CORRESPONDING_OPERATION_AUTHORITY = 6000541,
    ZIM_ERROR_CODE_GROUP_MODULE_FORBID_JOIN_GROUP_ERROR = 6000542,
    ZIM_ERROR_CODE_GROUP_MODULE_NEED_APPLY_JOIN_GROUP_ERROR = 6000543,

    ZIM_ERROR_CODE_CONVERSATION_MODULE_COMMON_ERROR = 6000601,
    ZIM_ERROR_CODE_CONVERSATION_MODULE_SERVER_ERROR = 6000602,
    ZIM_ERROR_CODE_CONVERSATION_MODULE_CONVERSATION_DOES_NOT_EXIST = 6000603,
    ZIM_ERROR_CODE_CONVERSATION_MODULE_CONVERSATION_PINNED_LIST_REACHED_LIMIT = 6000604,

    ZIM_ERROR_CODE_DATABASE_MODULE_OPEN_DATABASE_ERROR = 6000701,
    ZIM_ERROR_CODE_DATABASE_MODULE_MODIFY_DATABASE_ERROR = 6000702,
    ZIM_ERROR_CODE_DATABASE_MODULE_DELETE_DATABASE_ERROR = 6000703,
    ZIM_ERROR_CODE_DATABASE_MODULE_SELETE_DATABASE_ERROR = 6000704,

    ZIM_ERROR_CODE_FRIEND_MODULE_FRIENDS_NUM_LIMIT = 6000801,
    ZIM_ERROR_CODE_FRIEND_MODULE_FRIEND_APPLICATION_STATUS_ERROR = 6000802,
    ZIM_ERROR_CODE_FRIEND_MODULE_IS_ALREADY_YOUR_FRIEND = 6000803,
    ZIM_ERROR_CODE_FRIEND_MODULE_ALREADY_ADD_TO_BLACKLIST = 6000804,
    ZIM_ERROR_CODE_FRIEND_MODULE_CANNOT_ADD_SELF_TO_BLACKLIST = 6000805,
    ZIM_ERROR_CODE_FRIEND_MODULE_ALREADY_DELETE_FROM_BLACKLIST = 6000806,
    ZIM_ERROR_CODE_FRIEND_MODULE_USER_NOT_IN_BLACKLIST = 6000807,
    ZIM_ERROR_CODE_FRIEND_MODULE_BLACKLIST_LIST_QUANTITY_LIMIT = 6000808,
    ZIM_ERROR_CODE_FRIEND_MODULE_FRIEND_OPERATION_LIMIT_EXCEEDED = 6000809,
    ZIM_ERROR_CODE_FRIEND_MODULE_CANNOT_ADD_SELF_TO_FRIEND_LIST = 6000810,
    ZIM_ERROR_CODE_FRIEND_MODULE_FRIEND_ARE_UNREGISTERED = 6000811,
    ZIM_ERROR_CODE_FRIEND_MODULE_NOT_YOUR_FRIEND = 6000812,
    ZIM_ERROR_CODE_FRIEND_MODULE_CANNOT_DELETE_SELF = 6000813,
    ZIM_ERROR_CODE_FRIEND_MODULE_FRIEND_APPLICATION_EXPIRED = 6000814,
    ZIM_ERROR_CODE_FRIEND_MODULE_ADD_BLACKLIST_FAIL = 6000815,
    ZIM_ERROR_CODE_FRIEND_MODULE_DEL_BLACKLIST_FAIL = 6000816,
};

} // namespace zim

#endif //__ZIMERRORCODE_H__
